************************************************************************
*                                                                      *
      SUBROUTINE LDCSL2 (NCORE,NAME)
*                                                                      *
*   Open, check, load data from and close the  .csl  file. This file   *
*   is always attached to stream 21.                                   *
*                                                                      *
*   Call(s) to: [LIB92]: IQ, LENGTH, LODCSL, OPENFL.                   *
*                                                                      *
*   Written by Farid A. Parpia            Last revision: 23 Dec 1992   *
*                                                                      *
************************************************************************
*
      implicit double precision (a-h, o-z)
Cww      INTEGER PNTRIQ
      POINTER (PNTRIQ,RIQDUMMY)
      CHARACTER*24 NAME
      CHARACTER*15 RECORD
      CHARACTER*2 NH, NHFF
*
      include 'parameters.def'
CFF      INTEGER NNNW
CFF      PARAMETER (NNNW = 120)
      COMMON/DEF1/EMN,IONCTY,NELEC,Z
      COMMON/ORB2/NCF,NW,PNTRIQ
     :      /ORB4/NP(NNNW),NAK(NNNW)
     :      /ORB5/NKL(NNNW),NKJ(NNNW)
     :      /ORB10/NH(NNNW)
*
*     Common relevant for the radial wave functions of the final state.
*
      COMMON/DEF1FF/EMNFF,IONCTYFF,NELECFF,ZFF
      COMMON/ORB2FF/NCFFF,NWFF
     :      /ORB4FF/NPFF(NNNW),NAKFF(NNNW)
     :      /ORB5FF/NKLFF(NNNW),NKJFF(NNNW)
     :      /ORB10FF/NHFF(NNNW)
*
*   The  .csl  file is FORMATTED; it must exist
*
      J = INDEX(NAME,' ')
      OPEN (UNIT = 21,FILE=NAME(1:J-1)//'.c',FORM='FORMATTED',
     :     STATUS='OLD')
*
*   Check the first record of the file; if not as expected, try again
*
      READ (21,'(1A15)',IOSTAT = IOS) RECORD
      IF ((IOS .NE. 0) .OR.
     :    (RECORD(1:15) .NE. 'Core subshells:')) THEN
         PRINT *, 'Not a Configuration Symmetry List File;'
         CLOSE (21)
         STOP
      ENDIF
*
*   Load data from the  .csl  file
*
      CALL LODCSL (NCORER)
*
*   Close the  .csl  file
*
      CLOSE (21)
*
*   Check if the core should be redefined
*
      NCORE = NCORER
*      DO 3 I = NCORER+1,NW
*         IFULLI = NKJ(I)+1
*         DO 2 J = 1,NCF
*            IF (IQ (I,J) .NE. IFULLI) GOTO 4
*    2    CONTINUE
*         CALL CONVRT (NP(I),RECORD,LENTH)
*         PRINT *, 'Subshell '//RECORD(1:LENTH)//NH(I)//' is full'
*         PRINT *, ' in all CSFs; including this'
*         PRINT *, ' subshell in the core;'
*         NCORE = NCORE+1
*    3 CONTINUE
*
    4 CONTINUE
      NELECFF = NELEC
      NWFF = NW
      NCFFF = NCF
      DO 7 I = 1,NW
         NHFF(I) = NH(I)
         NPFF(I) = NP(I)
         NAKFF(I) = NAK(I)
         NKLFF(I) = NKL(I)
         NKJFF(I) = NKJ(I)
    7 CONTINUE
      RETURN
      END
